var mimetype = {};

mimetype._mapping = {
	"bmp":	 {"mime":"image\/bmp","icon":"image","type":"1"},
	"png":	 {"mime":"image\/png","icon":"image","type":"1"},
	"gif":	 {"mime":"image\/gif","icon":"image","type":"1"},
	"psd":	 {"mime":"image\/psd","icon":"image","type":"1"},
	"pcx":	 {"mime":"image\/pcx","icon":"image","type":"1"},
	"dcr":	 {"mime":"application\/x-director","icon":"image","type":"1"},
	"cgm":	 {"mime":"image\/cgm","icon":"image","type":"1"},
	"ief":	 {"mime":"image\/ief","icon":"image","type":"1"},
	"jpeg":	 {"mime":"image\/jpeg","icon":"image","type":"1"},
	"jpg":	 {"mime":"image\/jpeg","icon":"image","type":"1"},
	"jpe":	 {"mime":"image\/jpeg","icon":"image","type":"1"},
	"svg":	 {"mime":"image\/svg+xml","icon":"image","type":"1"},
	"tiff":	 {"mime":"image\/tiff","icon":"image","type":"1"},
	"tif":	 {"mime":"image\/tiff","icon":"image","type":"1"},
	"djvu":	 {"mime":"image\/vnd.djvu","icon":"image","type":"1"},
	"djv":	 {"mime":"image\/vnd.djvu","icon":"image","type":"1"},
	"wbmp":	 {"mime":"image\/vnd.wap.wbmp","icon":"image","type":"1"},
	"ras":	 {"mime":"image\/x-cmu-raster","icon":"image","type":"1"},
	"ico":	 {"mime":"image\/x-icon","icon":"image","type":"1"},
	"pnm":	 {"mime":"image\/x-portable-anymap","icon":"image","type":"1"},
	"pbm":	 {"mime":"image\/x-portable-bitmap","icon":"image","type":"1"},
	"pgm":	 {"mime":"image\/x-portable-graymap","icon":"image","type":"1"},
	"ppm":	 {"mime":"image\/x-portable-pixmap","icon":"image","type":"1"},
	"rgb":	 {"mime":"image\/x-rgb","icon":"image","type":"1"},
	"xbm":	 {"mime":"image\/x-xbitmap","icon":"image","type":"1"},
	"xpm":	 {"mime":"image\/x-xpixmap","icon":"image","type":"1"},
	"xwd":	 {"mime":"image\/x-xwindowdump","icon":"image","type":"1"},
	"cdr":	 {"mime":"image\/x-coreldraw","icon":"image","type":"1"},
	"cdt":	 {"mime":"image\/x-coreldrawtemplate","icon":"image","type":"1"},
	"jng":	 {"mime":"image\/x-jng","icon":"image","type":"1"},
	"pat":	 {"mime":"image\/x-coreldrawpattern","icon":"image","type":"1"},
	"dib":	 {"mime":"image\/bmp","icon":"image","type":"1"},
	"jp2":	 {"mime":"image\/jpeg2000","icon":"image","type":"1"},
	"mac":	 {"mime":"image\/x-macpaint","icon":"image","type":"1"},
	"pic":	 {"mime":"image\/x-pict","icon":"image","type":"1"},
	"pict":	 {"mime":"image\/x-pict","icon":"image","type":"1"},
	"pct":	 {"mime":"image\/x-pict","icon":"image","type":"1"},
	"pnt":	 {"mime":"image\/x-macpaint","icon":"image","type":"1"},
	"pntg":	 {"mime":"image\/x-macpaint","icon":"image","type":"1"},
	"pxr":	 {"mime":"image\/pxr","icon":"image","type":"1"},
	"qti":	 {"mime":"image\/x-quicktime","icon":"image","type":"1"},
	"qtif":	 {"mime":"image\/x-quicktime","icon":"image","type":"1"},
	"sgi":	 {"mime":"image\/x-sgi","icon":"image","type":"1"},
	"tga":	 {"mime":"image\/x-targa","icon":"image","type":"1"},
	"dng":	 {"mime":"image\/dng","icon":"image","type":"1"},
	"cr2":	 {"mime":"image\/x-raw","icon":"image","type":"1"},
	"crw":	 {"mime":"image\/x-raw","icon":"image","type":"1"},
	"nef":	 {"mime":"image\/x-raw","icon":"image","type":"1"},
	"pef":	 {"mime":"image\/x-pef","icon":"image","type":"1"},
	"orf":	 {"mime":"image\/x-olympus-orf","icon":"image","type":"1"},
	"ogg":	 {"mime":"audio\/ogg","icon":"audio","type":"2"},
	"au":	 {"mime":"audio\/basic","icon":"audio","type":"2"},
	"snd":	 {"mime":"audio\/basic","icon":"audio","type":"2"},
	"mid":	 {"mime":"audio\/midi","icon":"audio","type":"2"},
	"midi":	 {"mime":"audio\/midi","icon":"audio","type":"2"},
	"kar":	 {"mime":"audio\/midi","icon":"audio","type":"2"},
	"mpga":	 {"mime":"audio\/mpeg","icon":"audio","type":"2"},
	"mp2":	 {"mime":"audio\/mpeg","icon":"audio","type":"2"},
	"mp3":	 {"mime":"audio\/mpeg","icon":"audio","type":"2"},
	"aif":	 {"mime":"audio\/aiff","icon":"audio","type":"2"},
	"aiff":	 {"mime":"audio\/aiff","icon":"audio","type":"2"},
	"aifc":	 {"mime":"audio\/aiff","icon":"audio","type":"2"},
	"m3u":	 {"mime":"audio\/x-mpegurl","icon":"audio","type":"2"},
	"ram":	 {"mime":"audio\/x-pn-realaudio","icon":"audio","type":"2"},
	"ra":	 {"mime":"audio\/vnd.rn-realaudio","icon":"audio","type":"2"},
	"wav":	 {"mime":"audio\/wav","icon":"audio","type":"2"},
	"pls":	 {"mime":"audio\/scpls","icon":"audio","type":"2"},
	"wma":	 {"mime":"audio\/x-ms-wma","icon":"audio","type":"2"},
	"mp4":	 {"mime":"video\/x-m4v","icon":"video","type":"3"},
	"gsm":	 {"mime":"audio\/x-gsm","icon":"audio","type":"2"},
	"mpega":	 {"mime":"audio\/mpeg","icon":"audio","type":"2"},
	"amr":	 {"mime":"audio\/amr","icon":"audio","type":"2"},
	"cdda":	 {"mime":"audio\/aiff","icon":"audio","type":"2"},
	"qcp":	 {"mime":"audio\/vnd.qcelp","icon":"audio","type":"2"},
	"smf":	 {"mime":"audio\/midi","icon":"audio","type":"2"},
	"aac":	 {"mime":"audio\/x-aac","icon":"audio","type":"2"},
	"adts":	 {"mime":"audio\/x-aac","icon":"audio","type":"2"},
	"caf":	 {"mime":"audio\/x-caf","icon":"audio","type":"2"},
	"m4b":	 {"mime":"audio\/x-m4b","icon":"audio","type":"2"},
	"swa":	 {"mime":"audio\/x-mpeg3","icon":"audio","type":"2"},
	"m4a":	 {"mime":"audio\/mpeg","icon":"audio","type":"2"},
	"wax":	 {"mime":"audio\/x-ms-wax","icon":"audio","type":"2"},
	"asx":	 {"mime":"video\/x-ms-asf","icon":"video","type":"3"},
	"mpg":	 {"mime":"video\/mpeg","icon":"video","type":"3"},
	"rm":	 {"mime":"application\/vnd.rn-realmedia","icon":"video","type":"3"},
	"mpeg":	 {"mime":"video\/mpeg","icon":"video","type":"3"},
	"mpe":	 {"mime":"video\/mpeg","icon":"video","type":"3"},
	"qt":	 {"mime":"video\/quicktime","icon":"video","type":"3"},
	"mov":	 {"mime":"video\/quicktime","icon":"video","type":"3"},
	"mxu":	 {"mime":"video\/vnd.mpegurl","icon":"video","type":"3"},
	"m4u":	 {"mime":"video\/vnd.mpegurl","icon":"video","type":"3"},
	"avi":	 {"mime":"video\/avi","icon":"video","type":"3"},
	"movie":	 {"mime":"video\/x-sgi-movie","icon":"video","type":"3"},
	"wmv":	 {"mime":"video\/x-ms-wmv","icon":"video","type":"3"},
	"asf":	 {"mime":"video\/x-ms-asf","icon":"video","type":"3"},
	"rv":	 {"mime":"video\/vnd.rn-realvideo","icon":"video","type":"3"},
	"wmx":	 {"mime":"video\/x-ms-wmv","icon":"video","type":"3"},
	"flv":	 {"mime":"video\/x-flv","icon":"video","type":"3"},
	"vob":	 {"mime":"video\/mpeg","icon":"video","type":"3"},
	"3gp":	 {"mime":"video\/3gpp","icon":"video","type":"3"},
	"3gpp":	 {"mime":"video\/3gpp","icon":"video","type":"3"},
	"riff":	 {"mime":"video\/avi","icon":"video","type":"3"},
	"mpeg4":	 {"mime":"video\/mp4","icon":"video","type":"3"},
	"dl":	 {"mime":"video\/dl","icon":"video","type":"3"},
	"fli":	 {"mime":"video\/fli","icon":"video","type":"3"},
	"gl":	 {"mime":"video\/gl","icon":"video","type":"3"},
	"mng":	 {"mime":"video\/x-mng","icon":"video","type":"3"},
	"mqv":	 {"mime":"video\/quicktime","icon":"video","type":"3"},
	"3g2":	 {"mime":"video\/3gpp2","icon":"video","type":"3"},
	"3gp2":	 {"mime":"video\/3gpp2","icon":"video","type":"3"},
	"flc":	 {"mime":"video\/flc","icon":"video","type":"3"},
	"m4v":	 {"mime":"video\/x-m4v","icon":"video","type":"3"},
	"sdv":	 {"mime":"video\/sd-video","icon":"video","type":"3"},
	"vfw":	 {"mime":"video\/msvideo","icon":"video","type":"3"},
	"divx":	 {"mime":"video\/divx","icon":"video","type":"3"},
	"mts":	 {"mime":"video\/vnd.mts","icon":"video","type":"3"},
	"m2ts":	 {"mime":"video\/mpeg","icon":"video","type":"3"},
	"mkv":	 {"mime":"video\/mkv","icon":"video","type":"3"},
	"webm":	 {"mime":"video\/webm","icon":"video","type":"3"},
	"pdf":	 {"mime":"application\/pdf","icon":"pdf","type":"4"},
	"html":	 {"mime":"text\/html","icon":"html","type":"4"},
	"doc":	 {"mime":"application\/msword","icon":"doc","type":"4"},
	"ini":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"wpl":	 {"mime":"text\/html","icon":"html","type":"4"},
	"gz":	 {"mime":"application\/x-gzip","icon":"html","type":"4"},
	"rar":	 {"mime":"application\/octet-stream","icon":"rar","type":"4"},
	"eps":	 {"mime":"application\/postscript","icon":"image","type":"4"},
	"htm":	 {"mime":"text\/html","icon":"html","type":"4"},
	"pps":	 {"mime":"application\/vnd.ms-powerpoint","icon":"ppt","type":"4"},
	"php":	 {"mime":"text\/plain","icon":"text","type":"4"},
	"dmg":	 {"mime":"application\/octet-stream","icon":"dmg","type":"4"},
	"ez":	 {"mime":"application\/andrew-inset","icon":"binary","type":"4"},
	"atom":	 {"mime":"application\/atom+xml","icon":"xml","type":"4"},
	"hqx":	 {"mime":"application\/mac-binhex40","icon":"zip","type":"4"},
	"cpt":	 {"mime":"image\/x-corelphotopaint","icon":"binary","type":"4"},
	"mathml":	 {"mime":"application\/mathml+xml","icon":"xml","type":"4"},
	"bin":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"dms":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"lha":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"lzh":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"exe":	 {"mime":"application\/x-ms-dos-executable","icon":"binary","type":"4"},
	"class":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"so":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"dll":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"oda":	 {"mime":"application\/oda","icon":"binary","type":"4"},
	"ai":	 {"mime":"application\/postscript","icon":"image","type":"4"},
	"ps":	 {"mime":"application\/postscript","icon":"image","type":"4"},
	"rdf":	 {"mime":"application\/rdf+xml","icon":"xml","type":"4"},
	"smi":	 {"mime":"application\/smil","icon":"html","type":"4"},
	"smil":	 {"mime":"application\/smil","icon":"html","type":"4"},
	"gram":	 {"mime":"application\/srgs","icon":"binary","type":"4"},
	"grxml":	 {"mime":"application\/srgs+xml","icon":"xml","type":"4"},
	"mif":	 {"mime":"application\/vnd.mif","icon":"binary","type":"4"},
	"xul":	 {"mime":"application\/vnd.mozilla.xul+xml","icon":"xml","type":"4"},
	"xls":	 {"mime":"application\/vnd.ms-excel","icon":"xls","type":"4"},
	"ppt":	 {"mime":"application\/vnd.ms-powerpoint","icon":"ppt","type":"4"},
	"wbxml":	 {"mime":"application\/vnd.wap.wbxml","icon":"binary","type":"4"},
	"wmlc":	 {"mime":"application\/vnd.wap.wmlc","icon":"binary","type":"4"},
	"wmlsc":	 {"mime":"application\/vnd.wap.wmlscriptc","icon":"binary","type":"4"},
	"vxml":	 {"mime":"application\/voicexml+xml","icon":"xml","type":"4"},
	"bcpio":	 {"mime":"application\/x-bcpio","icon":"binary","type":"4"},
	"vcd":	 {"mime":"application\/x-cdlink","icon":"binary","type":"4"},
	"pgn":	 {"mime":"application\/x-chess-pgn","icon":"binary","type":"4"},
	"cpio":	 {"mime":"application\/x-cpio","icon":"binary","type":"4"},
	"csh":	 {"mime":"application\/x-csh","icon":"binary","type":"4"},
	"dir":	 {"mime":"application\/x-director","icon":"image","type":"4"},
	"dxr":	 {"mime":"application\/x-director","icon":"image","type":"4"},
	"dvi":	 {"mime":"application\/x-dvi","icon":"binary","type":"4"},
	"spl":	 {"mime":"application\/x-futuresplash","icon":"binary","type":"4"},
	"gtar":	 {"mime":"application\/x-gtar","icon":"tgz","type":"4"},
	"hdf":	 {"mime":"application\/x-hdf","icon":"binary","type":"4"},
	"js":	 {"mime":"application\/x-javascript","icon":"js","type":"4"},
	"skp":	 {"mime":"application\/x-koan","icon":"binary","type":"4"},
	"skd":	 {"mime":"application\/x-koan","icon":"binary","type":"4"},
	"skt":	 {"mime":"application\/x-koan","icon":"binary","type":"4"},
	"skm":	 {"mime":"application\/x-koan","icon":"binary","type":"4"},
	"latex":	 {"mime":"application\/x-latex","icon":"text","type":"4"},
	"nc":	 {"mime":"application\/x-netcdf","icon":"binary","type":"4"},
	"cdf":	 {"mime":"application\/x-netcdf","icon":"binary","type":"4"},
	"sh":	 {"mime":"application\/x-sh","icon":"binary","type":"4"},
	"shar":	 {"mime":"application\/x-shar","icon":"binary","type":"4"},
	"swf":	 {"mime":"application\/x-shockwave-flash","icon":"fla","type":"4"},
	"sit":	 {"mime":"application\/x-stuffit","icon":"zip","type":"4"},
	"sv4cpio":	 {"mime":"application\/x-sv4cpio","icon":"binary","type":"4"},
	"sv4crc":	 {"mime":"application\/x-sv4crc","icon":"binary","type":"4"},
	"tar":	 {"mime":"application\/x-tar","icon":"tgz","type":"4"},
	"tcl":	 {"mime":"application\/x-tcl","icon":"binary","type":"4"},
	"tex":	 {"mime":"application\/x-tex","icon":"binary","type":"4"},
	"texinfo":	 {"mime":"application\/x-texinfo","icon":"binary","type":"4"},
	"texi":	 {"mime":"application\/x-texinfo","icon":"binary","type":"4"},
	"t":	 {"mime":"application\/x-troff","icon":"binary","type":"4"},
	"tr":	 {"mime":"application\/x-troff","icon":"binary","type":"4"},
	"roff":	 {"mime":"application\/x-troff","icon":"binary","type":"4"},
	"man":	 {"mime":"application\/x-troff-man","icon":"binary","type":"4"},
	"me":	 {"mime":"application\/x-troff-me","icon":"binary","type":"4"},
	"ms":	 {"mime":"application\/x-troff-ms","icon":"binary","type":"4"},
	"ustar":	 {"mime":"application\/x-ustar","icon":"binary","type":"4"},
	"src":	 {"mime":"application\/x-wais-source","icon":"binary","type":"4"},
	"xhtml":	 {"mime":"application\/xhtml+xml","icon":"html","type":"4"},
	"xht":	 {"mime":"application\/xhtml+xml","icon":"html","type":"4"},
	"xslt":	 {"mime":"application\/xslt+xml","icon":"xml","type":"4"},
	"xml":	 {"mime":"application\/xml","icon":"xml","type":"4"},
	"xsl":	 {"mime":"application\/xml","icon":"xml","type":"4"},
	"dtd":	 {"mime":"application\/xml-dtd","icon":"xml","type":"4"},
	"zip":	 {"mime":"application\/zip","icon":"zip","type":"4"},
	"ics":	 {"mime":"text\/calendar","icon":"text","type":"4"},
	"ifb":	 {"mime":"text\/calendar","icon":"text","type":"4"},
	"css":	 {"mime":"text\/css","icon":"html","type":"4"},
	"asc":	 {"mime":"text\/plain","icon":"text","type":"4"},
	"txt":	 {"mime":"text\/plain","icon":"text","type":"4"},
	"rtx":	 {"mime":"text\/richtext","icon":"text","type":"4"},
	"rtf":	 {"mime":"text\/rtf","icon":"text","type":"4"},
	"sgml":	 {"mime":"text\/sgml","icon":"text","type":"4"},
	"sgm":	 {"mime":"text\/sgml","icon":"text","type":"4"},
	"tsv":	 {"mime":"text\/tab-separated-values","icon":"text","type":"4"},
	"wml":	 {"mime":"text\/vnd.wap.wml","icon":"html","type":"4"},
	"wmls":	 {"mime":"text\/vnd.wap.wmlscript","icon":"text","type":"4"},
	"etx":	 {"mime":"text\/x-setext","icon":"text","type":"4"},
	"csv":	 {"mime":"application\/octet-stream","icon":"xls","type":"4"},
	"unknown":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"bz2":	 {"mime":"application\/x-bzip","icon":"tar","type":"4"},
	"torrent":	 {"mime":"application\/x-bittorrent","icon":"torrent","type":"4"},
	"pov":	 {"mime":"text\/plain","icon":"text","type":"4"},
	"inf":	 {"mime":"text\/plain","icon":"text","type":"4"},
	"log":	 {"mime":"text\/plain","icon":"text","type":"4"},
	"dot":	 {"mime":"application\/msword","icon":"doc","type":"4"},
	"xlt":	 {"mime":"application\/vnd.ms-excel","icon":"xls","type":"4"},
	"docm":	 {"mime":"application\/vnd.ms-word.document.macroenabled.12","icon":"doc","type":"4"},
	"docx":	 {"mime":"application\/vnd.openxmlformats-officedocument.wordprocessingml.document","icon":"doc","type":"4"},
	"dotm":	 {"mime":"application\/vnd.ms-word.template.macroenabled.12","icon":"doc","type":"4"},
	"dotx":	 {"mime":"application\/vnd.openxmlformats-officedocument.wordprocessingml.template","icon":"doc","type":"4"},
	"potm":	 {"mime":"application\/vnd.ms-powerpoint.template.macroenabled.12","icon":"ppt","type":"4"},
	"potx":	 {"mime":"application\/vnd.openxmlformats-officedocument.presentationml.template","icon":"ppt","type":"4"},
	"ppam":	 {"mime":"application\/vnd.ms-powerpoint.addin.macroenabled.12","icon":"ppt","type":"4"},
	"ppsm":	 {"mime":"application\/vnd.ms-powerpoint.slideshow.macroenabled.12","icon":"ppt","type":"4"},
	"ppsx":	 {"mime":"application\/vnd.openxmlformats-officedocument.presentationml.slideshow","icon":"ppt","type":"4"},
	"pptm":	 {"mime":"application\/vnd.ms-powerpoint.presentation.macroenabled.12","icon":"ppt","type":"4"},
	"pptx":	 {"mime":"application\/vnd.openxmlformats-officedocument.presentationml.presentation","icon":"ppt","type":"4"},
	"xlam":	 {"mime":"application\/vnd.ms-excel.addin.macroenabled.12","icon":"xls","type":"4"},
	"xlsb":	 {"mime":"application\/vnd.ms-excel.sheet.binary.macroenabled.12","icon":"xls","type":"4"},
	"xlsm":	 {"mime":"application\/vnd.ms-excel.sheet.macroenabled.12","icon":"xls","type":"4"},
	"xlsx":	 {"mime":"application\/vnd.openxmlformats-officedocument.spreadsheetml.sheet","icon":"xls","type":"4"},
	"xltm":	 {"mime":"application\/vnd.ms-excel.template.macroenabled.12","icon":"xls","type":"4"},
	"xltx":	 {"mime":"application\/vnd.openxmlformats-officedocument.spreadsheetml.template","icon":"xls","type":"4"},
	"7z":	 {"mime":"application\/x-7z-compressed","icon":"zip","type":"4"},
	"arw":	 {"mime":"image\/x-raw","icon":"image","type":"4"},
	"axx":	 {"mime":"application\/octet-stream","icon":"zip","type":"4"},
	"chm":	 {"mime":"application\/x-chm","icon":"html","type":"4"},
	"db":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"eml":	 {"mime":"message\/rfc822","icon":"binary","type":"4"},
	"lnk":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"mht":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"odt":	 {"mime":"application\/vnd.oasis.opendocument.text","icon":"text","type":"4"},
	"ptf":	 {"mime":"application\/octet-stream","icon":"binary","type":"4"},
	"raw":	 {"mime":"image\/raw","icon":"image","type":"4"},
	"srf":	 {"mime":"image\/x-raw","icon":"image","type":"4"},
	"sr2":	 {"mime":"image\/x-raw","icon":"image","type":"4"},
	"ttf":	 {"mime":"application\/x-font-ttf","icon":"binary","type":"4"},
	"wp":	 {"mime":"application\/octet-stream","icon":"text","type":"4"},
	"wpd":	 {"mime":"application\/octet-stream","icon":"text","type":"4"},
	"wpg":	 {"mime":"image\/x-wpg","icon":"image","type":"4"},
	"xmp":	 {"mime":"application\/octet-stream","icon":"xml","type":"4"},
	"ods":	 {"mime":"application\/vnd.oasis.opendocument.spreadsheet","icon":"xls","type":"4"},
	"odp":	 {"mime":"application\/vnd.oasis.opendocument.presentation","icon":"ppt","type":"4"},
	"odg":	 {"mime":"application\/vnd.oasis.opendocument.graphics","icon":"image","type":"4"},
	"odf":	 {"mime":"application\/vnd.oasis.opendocument.formula","icon":"binary","type":"4"}		
	};
	
	mimetype.get_icon = function ( filename )
	{
		var path = "chrome://uploadr/skin/mimetype/";

		var ext = filename.toLowerCase().split(".").pop();
				
		if ( mimetype._mapping [ ext ] ) return path + mimetype._mapping [ ext ].icon + ".png";
		
		return path + mimetype._mapping['unknown'].icon + ".png";
	};
	
	mimetype.get_type = function ( filename )
	{
		var ext = filename.toLowerCase().split(".").pop();
		
		if ( mimetype._mapping [ ext ] && mimetype._mapping [ ext ].type ) return mimetype._mapping[ext].type;
		
		return null
	};


